## mingw-w64-catch-3.11.0-1.src.tar.zst

=== benchmarks/CMakeLists.txt ===
include(CatchMiscFunctions)

add_executable(AssertionsFastPath
  runtime_assertion_benches.cpp
)

add_executable(AssertionsSlowPath
  runtime_assertion_benches.cpp
  assertion_listener.cpp
)

target_link_libraries(AssertionsFastPath PRIVATE Catch2::Catch2WithMain)
target_link_libraries(AssertionsSlowPath PRIVATE Catch2::Catch2WithMain)

list(APPEND CATCH_TEST_TARGETS AssertionsFastPath AssertionsSlowPath)
set(CATCH_TEST_TARGETS ${CATCH_TEST_TARGETS} PARENT_SCOPE)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(Catch2Examples LANGUAGES CXX)

message(STATUS "Examples included")

# Some one-offs first:
# 1) Tests and main in one file
add_executable(010-TestCase
  010-TestCase.cpp
)

# 2) Tests and main across two files
add_executable(020-MultiFile
  020-TestCase-1.cpp
  020-TestCase-2.cpp
)

add_executable(231-Cfg_OutputStreams
  231-Cfg-OutputStreams.cpp
)
target_link_libraries(231-Cfg_OutputStreams Catch2_buildall_interface)
target_compile_definitions(231-Cfg_OutputStreams PUBLIC CATCH_CONFIG_NOSTDOUT)

# These examples use the standard separate compilation
set(SOURCES_IDIOMATIC_EXAMPLES
  030-Asn-Require-Check.cpp
  100-Fix-Section.cpp
  110-Fix-ClassFixture.cpp
  111-Fix-PersistentFixture.cpp
  120-Bdd-ScenarioGivenWhenThen.cpp
  210-Evt-EventListeners.cpp
  232-Cfg-CustomMain.cpp
  300-Gen-OwnGenerator.cpp
  301-Gen-MapTypeConversion.cpp
  302-Gen-Table.cpp
  310-Gen-VariablesInGenerators.cpp
  311-Gen-CustomCapture.cpp
)

string(REPLACE ".cpp" "" BASENAMES_IDIOMATIC_EXAMPLES "${SOURCES_IDIOMATIC_EXAMPLES}")
set(TARGETS_IDIOMATIC_EXAMPLES ${BASENAMES_IDIOMATIC_EXAMPLES})

foreach(name ${TARGETS_IDIOMATIC_EXAMPLES})
  add_executable(${name} ${name}.cpp)
endforeach()

set(ALL_EXAMPLE_TARGETS
  ${TARGETS_IDIOMATIC_EXAMPLES}
  010-TestCase
  020-MultiFile
)

foreach(name ${ALL_EXAMPLE_TARGETS})
  target_link_libraries(${name} Catch2WithMain)
endforeach()

list(APPEND CATCH_TEST_TARGETS ${ALL_EXAMPLE_TARGETS})
set(CATCH_TEST_TARGETS ${CATCH_TEST_TARGETS} PARENT_SCOPE)

=== src/CMakeLists.txt ===
include(CatchMiscFunctions)

# CMake derives a Visual Studio project GUID from the file path but can be overridden via a property
# (see https://gitlab.kitware.com/cmake/cmake/-/commit/c85367f4).  Using a non-constant GUID
# can cause problems if other projects/repos want to reference the vcxproj file,
# so we force a constant GUID here.
set(Catch2_GUID_CMAKE "8d538cbe-01bf-4a2e-a98a-6c368fdf13d7" CACHE INTERNAL "Project GUID")
set(Catch2WithMain_GUID_CMAKE "8bd3552a-2cfb-4a59-ab15-2031b97ada1e" CACHE INTERNAL "Project GUID")

set(BENCHMARK_HEADERS
  ${SOURCES_DIR}/benchmark/catch_benchmark.hpp
  ${SOURCES_DIR}/benchmark/catch_benchmark_all.hpp
  ${SOURCES_DIR}/benchmark/catch_chronometer.hpp
  ${SOURCES_DIR}/benchmark/catch_clock.hpp
  ${SOURCES_DIR}/benchmark/catch_constructor.hpp
  ${SOURCES_DIR}/benchmark/catch_environment.hpp
  ${SOURCES_DIR}/benchmark/catch_estimate.hpp
  ${SOURCES_DIR}/benchmark/catch_execution_plan.hpp
  ${SOURCES_DIR}/benchmark/catch_optimizer.hpp
  ${SOURCES_DIR}/benchmark/catch_outlier_classification.hpp
  ${SOURCES_DIR}/benchmark/catch_sample_analysis.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_analyse.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_benchmark_function.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_benchmark_stats.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_benchmark_stats_fwd.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_complete_invoke.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_estimate_clock.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_measure.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_repeat.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_run_for_at_least.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_stats.hpp
  ${SOURCES_DIR}/benchmark/detail/catch_timing.hpp
)
set(BENCHMARK_SOURCES
  ${SOURCES_DIR}/benchmark/catch_chronometer.cpp
  ${SOURCES_DIR}/benchmark/detail/catch_analyse.cpp
  ${SOURCES_DIR}/benchmark/detail/catch_benchmark_function.cpp
  ${SOURCES_DIR}/benchmark/detail/catch_run_for_at_least.cpp
  ${SOURCES_DIR}/benchmark/detail/catch_stats.cpp
)
set(BENCHMARK_FILES ${BENCHMARK_HEADERS} ${BENCHMARK_SOURCES})

set(IMPL_HEADERS
 "${PROJECT_BINARY_DIR}/generated-includes/catch2/catch_user_config.hpp"
  ${SOURCES_DIR}/catch_user_config.hpp.in
  ${SOURCES_DIR}/catch_all.hpp
  ${SOURCES_DIR}/catch_approx.hpp
  ${SOURCES_DIR}/catch_assertion_info.hpp
  ${SOURCES_DIR}/catch_assertion_result.hpp
  ${SOURCES_DIR}/catch_case_sensitive.hpp
  ${SOURCES_DIR}/catch_config.hpp
  ${SOURCES_DIR}/catch_get_random_seed.hpp
  ${SOURCES_DIR}/catch_message.hpp
  ${SOURCES_DIR}/catch_section_info.hpp
  ${SOURCES_DIR}/catch_session.hpp
  ${SOURCES_DIR}/catch_tag_alias.hpp
  ${SOURCES_DIR}/catch_tag_alias_autoregistrar.hpp
  ${SOURCES_DIR}/catch_template_test_macros.hpp
  ${SOURCES_DIR}/catch_test_case_info.hpp
  ${SOURCES_DIR}/catch_test_macros.hpp
  ${SOURCES_DIR}/catch_test_run_info.hpp
  ${SOURCES_DIR}/catch_test_spec.hpp
  ${SOURCES_DIR}/catch_timer.hpp
  ${SOURCES_DIR}/catch_tostring.hpp
  ${SOURCES_DIR}/catch_totals.hpp
  ${SOURCES_DIR}/catch_translate_exception.hpp
  ${SOURCES_DIR}/catch_version.hpp
  ${SOURCES_DIR}/catch_version_macros.hpp
  ${SOURCES_DIR}/internal/catch_assertion_handler.hpp
  ${SOURCES_DIR}/internal/catch_case_insensitive_comparisons.hpp
  ${SOURCES_DIR}/internal/catch_clara.hpp
  ${SOURCES_DIR}/internal/catch_commandline.hpp
  ${SOURCES_DIR}/internal/catch_compare_traits.hpp
  ${SOURCES_DIR}/internal/catch_compiler_capabilities.hpp
  ${SOURCES_DIR}/internal/catch_config_android_logwrite.hpp
  ${SOURCES_DIR}/internal/catch_config_counter.hpp
  ${SOURCES_DIR}/internal/catch_config_prefix_messages.hpp
  ${SOURCES_DIR}/internal/catch_config_static_analysis_support.hpp
  ${SOURCES_DIR}/internal/catch_config_uncaught_exceptions.hpp
  ${SOURCES_DIR}/internal/catch_config_wchar.hpp
  ${SOURCES_DIR}/internal/catch_console_colour.hpp
  ${SOURCES_DIR}/internal/catch_console_width.hpp
  ${SOURCES_DIR}/internal/catch_container_nonmembers.hpp
  ${SOURCES_DIR}/internal/catch_context.hpp
  ${SOURCES_DIR}/internal/catch_debug_console.hpp
  ${SOURCES_DIR}/internal/catch_debugger.hpp
  ${SOURCES_DIR}/internal/catch_decomposer.hpp
  ${SOURCES_DIR}/internal/catch_deprecation_macro.hpp
  ${SOURCES_DIR}/internal/catch_enforce.hpp
  ${SOURCES_DIR}/internal/catch_enum_values_registry.hpp
  ${SOURCES_DIR}/internal/catch_errno_guard.hpp
  ${SOURCES_DIR}/internal/catch_exception_translator_registry.hpp
  ${SOURCES_DIR}/internal/catch_fatal_condition_handler.hpp
  ${SOURCES_DIR}/internal/catch_floating_point_helpers.hpp
  ${SOURCES_DIR}/internal/catch_getenv.hpp
  ${SOURCES_DIR}/internal/catch_istream.hpp
  ${SOURCES_DIR}/internal/catch_is_permutation.hpp
  ${SOURCES_DIR}/internal/catch_jsonwriter.hpp
  ${SOURCES_DIR}/internal/catch_lazy_expr.hpp
  ${SOURCES_DIR}/internal/catch_leak_detector.hpp
  ${SOURCES_DIR}/internal/catch_list.hpp
  ${SOURCES_DIR}/internal/catch_logical_traits.hpp
  ${SOURCES_DIR}/internal/catch_message_info.hpp
  ${SOURCES_DIR}/internal/catch_meta.hpp
  ${SOURCES_DIR}/internal/catch_move_and_forward.hpp
  ${SOURCES_DIR}/internal/catch_noncopyable.hpp
  ${SOURCES_DIR}/internal/catch_optional.hpp
  ${SOURCES_DIR}/internal/catch_output_redirect.hpp
  ${SOURCES_DIR}/internal/catch_parse_numbers.hpp
  ${SOURCES_DIR}/internal/catch_platform.hpp
  ${SOURCES_DIR}/internal/catch_polyfills.hpp
  ${SOURCES_DIR}/internal/catch_preprocessor.hpp
  ${SOURCES_DIR}/internal/catch_preprocessor_remove_parens.hpp
  ${SOURCES_DIR}/internal/catch_random_floating_point_helpers.hpp
  ${SOURCES_DIR}/internal/catch_random_integer_helpers.hpp
  ${SOURCES_DIR}/internal/catch_random_number_generator.hpp
  ${SOURCES_DIR}/internal/catch_random_seed_generation.hpp
  ${SOURCES_DIR}/internal/catch_reporter_registry.hpp
  ${SOURCES_DIR}/internal/catch_reporter_spec_parser.hpp
  ${SOURCES_DIR}/internal/catch_result_type.hpp
  ${SOURCES_DIR}/internal/catch_reusable_string_stream.hpp
  ${SOURCES_DIR}/internal/catch_run_context.hpp
  ${SOURCES_DIR}/internal/catch_section.hpp
  ${SOURCES_DIR}/internal/catch_sharding.hpp
  ${SOURCES_DIR}/internal/catch_singletons.hpp
  ${SOURCES_DIR}/internal/catch_source_line_info.hpp
  ${SOURCES_DIR}/internal/catch_startup_exception_registry.hpp
  ${SOURCES_DIR}/internal/catch_stdstreams.hpp
  ${SOURCES_DIR}/internal/catch_stream_end_stop.hpp
  ${SOURCES_DIR}/internal/catch_string_manip.hpp
  ${SOURCES_DIR}/internal/catch_stringref.hpp
  ${SOURCES_DIR}/internal/catch_tag_alias_registry.hpp
  ${SOURCES_DIR}/internal/catch_template_test_registry.hpp
  ${SOURCES_DIR}/internal/catch_test_case_info_hasher.hpp
  ${SOURCES_DIR}/internal/catch_test_case_registry_impl.hpp
  ${SOURCES_DIR}/internal/catch_test_case_tracker.hpp
  ${SOURCES_DIR}/internal/catch_test_failure_exception.hpp
  ${SOURCES_DIR}/internal/catch_test_macro_impl.hpp
  ${SOURCES_DIR}/internal/catch_test_registry.hpp
  ${SOURCES_DIR}/internal/catch_test_spec_parser.hpp
  ${SOURCES_DIR}/internal/catch_textflow.hpp
  ${SOURCES_DIR}/internal/catch_thread_support.hpp
  ${SOURCES_DIR}/internal/catch_to_string.hpp
  ${SOURCES_DIR}/internal/catch_uncaught_exceptions.hpp
  ${SOURCES_DIR}/internal/catch_uniform_floating_point_distribution.hpp
  ${SOURCES_DIR}/internal/catch_uniform_integer_distribution.hpp
  ${SOURCES_DIR}/internal/catch_unique_name.hpp
  ${SOURCES_DIR}/internal/catch_unique_ptr.hpp
  ${SOURCES_DIR}/internal/catch_unreachable.hpp
  ${SOURCES_DIR}/internal/catch_void_type.hpp
  ${SOURCES_DIR}/internal/catch_wildcard_pattern.hpp
  ${SOURCES_DIR}/internal/catch_windows_h_proxy.hpp
  ${SOURCES_DIR}/internal/catch_xmlwriter.hpp
)
set(IMPL_SOURCES
  ${SOURCES_DIR}/catch_approx.cpp
  ${SOURCES_DIR}/catch_assertion_result.cpp
  ${SOURCES_DIR}/catch_config.cpp
  ${SOURCES_DIR}/catch_get_random_seed.cpp
  ${SOURCES_DIR}/catch_message.cpp
  ${SOURCES_DIR}/catch_registry_hub.cpp
  ${SOURCES_DIR}/catch_session.cpp
  ${SOURCES_DIR}/catch_tag_alias_autoregistrar.cpp
  ${SOURCES_DIR}/catch_test_case_info.cpp
  ${SOURCES_DIR}/catch_test_spec.cpp
  ${SOURCES_DIR}/catch_timer.cpp
  ${SOURCES_DIR}/catch_tostring.cpp
  ${SOURCES_DIR}/catch_totals.cpp
  ${SOURCES_DIR}/catch_translate_exception.cpp
  ${SOURCES_DIR}/catch_version.cpp
  ${SOURCES_DIR}/internal/catch_assertion_handler.cpp
  ${SOURCES_DIR}/internal/catch_case_insensitive_comparisons.cpp
  ${SOURCES_DIR}/internal/catch_clara.cpp
  ${SOURCES_DIR}/internal/catch_commandline.cpp
  ${SOURCES_DIR}/internal/catch_console_colour.cpp
  ${SOURCES_DIR}/internal/catch_context.cpp
  ${SOURCES_DIR}/internal/catch_debug_console.cpp
  ${SOURCES_DIR}/internal/catch_debugger.cpp
  ${SOURCES_DIR}/internal/catch_decomposer.cpp
  ${SOURCES_DIR}/internal/catch_enforce.cpp
  ${SOURCES_DIR}/internal/catch_enum_values_registry.cpp
  ${SOURCES_DIR}/internal/catch_errno_guard.cpp
  ${SOURCES_DIR}/internal/catch_exception_translator_registry.cpp
  ${SOURCES_DIR}/internal/catch_fatal_condition_handler.cpp
  ${SOURCES_DIR}/internal/catch_floating_point_helpers.cpp
  ${SOURCES_DIR}/internal/catch_getenv.cpp
  ${SOURCES_DIR}/internal/catch_istream.cpp
  ${SOURCES_DIR}/internal/catch_jsonwriter.cpp
  ${SOURCES_DIR}/internal/catch_lazy_expr.cpp
  ${SOURCES_DIR}/internal/catch_leak_detector.cpp
  ${SOURCES_DIR}/internal/catch_list.cpp
  ${SOURCES_DIR}/internal/catch_message_info.cpp
  ${SOURCES_DIR}/internal/catch_output_redirect.cpp
  ${SOURCES_DIR}/internal/catch_parse_numbers.cpp
  ${SOURCES_DIR}/internal/catch_polyfills.cpp
  ${SOURCES_DIR}/internal/catch_random_number_generator.cpp
  ${SOURCES_DIR}/internal/catch_random_seed_generation.cpp
  ${SOURCES_DIR}/internal/catch_reporter_registry.cpp
  ${SOURCES_DIR}/internal/catch_reporter_spec_parser.cpp
  ${SOURCES_DIR}/internal/catch_reusable_string_stream.cpp
  ${SOURCES_DIR}/internal/catch_run_context.cpp
  ${SOURCES_DIR}/internal/catch_section.cpp
  ${SOURCES_DIR}/internal/catch_singletons.cpp
  ${SOURCES_DIR}/internal/catch_source_line_info.cpp
  ${SOURCES_DIR}/internal/catch_startup_exception_registry.cpp
  ${SOURCES_DIR}/internal/catch_stdstreams.cpp
  ${SOURCES_DIR}/internal/catch_string_manip.cpp
  ${SOURCES_DIR}/internal/catch_stringref.cpp
  ${SOURCES_DIR}/internal/catch_tag_alias_registry.cpp
  ${SOURCES_DIR}/internal/catch_test_case_info_hasher.cpp
  ${SOURCES_DIR}/internal/catch_test_case_registry_impl.cpp
  ${SOURCES_DIR}/internal/catch_test_case_tracker.cpp
  ${SOURCES_DIR}/internal/catch_test_failure_exception.cpp
  ${SOURCES_DIR}/internal/catch_test_registry.cpp
  ${SOURCES_DIR}/internal/catch_test_spec_parser.cpp
  ${SOURCES_DIR}/internal/catch_textflow.cpp
  ${SOURCES_DIR}/internal/catch_uncaught_exceptions.cpp
  ${SOURCES_DIR}/internal/catch_wildcard_pattern.cpp
  ${SOURCES_DIR}/internal/catch_xmlwriter.cpp
)
set(INTERNAL_FILES ${IMPL_SOURCES} ${IMPL_HEADERS})

set(INTERFACE_HEADERS
  ${SOURCES_DIR}/interfaces/catch_interfaces_all.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_capture.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_config.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_enum_values_registry.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_exception.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_generatortracker.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_registry_hub.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_reporter.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_reporter_factory.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_tag_alias_registry.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_test_invoker.hpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_testcase.hpp
)
set(INTERFACE_SOURCES
  ${SOURCES_DIR}/interfaces/catch_interfaces_capture.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_config.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_exception.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_generatortracker.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_registry_hub.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_reporter.cpp
  ${SOURCES_DIR}/interfaces/catch_interfaces_reporter_factory.cpp

=== tests/CMakeLists.txt ===
include(CatchMiscFunctions)

if(CATCH_BUILD_SURROGATES)
  message(STATUS "Configuring targets for surrogate TUs")

  # If the folder does not exist before we ask for output redirect to
  # a file, it won't work.
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/surrogates)

  # Creates target to generate the surrogate TU for provided header.
  # Returns the path to the generated file.
  function(createSurrogateFileTarget sourceHeader pathToFile)
    set(pathPrefix ${PROJECT_SOURCE_DIR}/src)
    file(RELATIVE_PATH includePath ${pathPrefix} ${sourceHeader})

    get_filename_component(basicFileName "${sourceHeader}" NAME_WE)
    set(surrogateFilePath ${CMAKE_CURRENT_BINARY_DIR}/surrogates/surrogate_${basicFileName}.cpp)

    add_custom_command(
      OUTPUT ${surrogateFilePath}
      COMMAND cmake -E echo "\#include <${includePath}>" > "${surrogateFilePath}"
      VERBATIM
    )

    set(${pathToFile} ${surrogateFilePath} PARENT_SCOPE)
  endfunction()

  # Extracts all non-helper (e.g. catch_all.hpp) headers from the
  # Catch2 target, and returns them through the argument.
  function(ExtractCatch2Headers OutArg)
    get_target_property(targetSources Catch2 SOURCES)
    foreach(Source ${targetSources})
      string(REGEX MATCH "^.*\\.hpp$" isHeader ${Source})
      string(REGEX MATCH "_all.hpp" isAllHeader ${Source})
      if(isHeader AND NOT isAllHeader)
        list(APPEND AllHeaders ${Source})
      endif()
    endforeach()
    set(${OutArg} ${AllHeaders} PARENT_SCOPE)
  endfunction()

  ExtractCatch2Headers(mainHeaders)

  if(NOT mainHeaders)
    message(FATAL_ERROR "No headers in the main target were detected. Something is broken.")
  endif()

  foreach(header ${mainHeaders})
    createSurrogateFileTarget(${header} pathToGeneratedFile)
    list(APPEND surrogateFiles ${pathToGeneratedFile})
  endforeach()

  add_executable(Catch2SurrogateTarget
    ${surrogateFiles}
  )
  target_link_libraries(Catch2SurrogateTarget PRIVATE Catch2WithMain)
endif()

####
# Temporary workaround for VS toolset changes in 2017
# We need to disable <UseFullPaths> property, but CMake doesn't support it
# until 3.13 (not yet released)
####
if(MSVC)
  configure_file(${CATCH_DIR}/tools/misc/SelfTest.vcxproj.user ${CMAKE_BINARY_DIR}/tests COPYONLY)
endif() #Temporary workaround

# define the sources of the self test
# Please keep these ordered alphabetically
set(TEST_SOURCES
  ${SELF_TEST_DIR}/TestRegistrations.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Algorithms.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/AssertionHandler.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Clara.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/CmdLine.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/CmdLineHelpers.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/ColourImpl.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Details.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/FloatingPoint.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/GeneratorsImpl.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Integer.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/InternalBenchmark.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Json.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Parse.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/PartTracker.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/RandomNumberGeneration.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Reporters.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Tag.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/TestCaseInfoHasher.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/TestSpec.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/TestSpecParser.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/TextFlow.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Sharding.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Stream.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/String.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/StringManip.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Xml.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/Traits.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/ToString.tests.cpp
  ${SELF_TEST_DIR}/IntrospectiveTests/UniquePtr.tests.cpp
  ${SELF_TEST_DIR}/helpers/parse_test_spec.cpp
  ${SELF_TEST_DIR}/TimingTests/Sleep.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Approx.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/BDD.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Benchmark.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Class.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Compilation.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Condition.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Decomposition.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/EnumToString.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Exception.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Generators.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Message.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Misc.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Skip.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringByte.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringChrono.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringGeneral.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringOptional.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringPair.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringTuple.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringVariant.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringVector.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/ToStringWhich.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Tricky.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/VariadicMacros.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/MatchersRanges.tests.cpp
  ${SELF_TEST_DIR}/UsageTests/Matchers.tests.cpp
)

set(TEST_HEADERS
  ${SELF_TEST_DIR}/helpers/parse_test_spec.hpp
  ${SELF_TEST_DIR}/helpers/range_test_helpers.hpp
  ${SELF_TEST_DIR}/helpers/type_with_lit_0_comparisons.hpp
)

# Specify the headers, too, so CLion recognises them as project files
set(HEADERS
  ${TOP_LEVEL_HEADERS}
  ${EXTERNAL_HEADERS}
  ${INTERNAL_HEADERS}
  ${REPORTER_HEADERS}
  ${BENCHMARK_HEADERS}
  ${BENCHMARK_SOURCES}
)

# Provide some groupings for IDEs
#source_group("benchmark" FILES ${BENCHMARK_HEADERS} ${BENCHMARK_SOURCES})
#source_group("Tests" FILES ${TEST_SOURCES})

include(CTest)

add_executable(SelfTest ${TEST_SOURCES} ${TEST_HEADERS})
target_include_directories(SelfTest PRIVATE ${SELF_TEST_DIR})
target_link_libraries(SelfTest PRIVATE Catch2WithMain)
if(BUILD_SHARED_LIBS AND WIN32)
  add_custom_command(TARGET SelfTest PRE_LINK
    COMMAND ${CMAKE_COMMAND} -E copy_if_different $<TARGET_FILE:Catch2>
    $<TARGET_FILE:Catch2WithMain> $<TARGET_FILE_DIR:SelfTest>
  )
endif()

if(CATCH_ENABLE_COVERAGE)
  set(ENABLE_COVERAGE ON CACHE BOOL "Enable coverage build." FORCE)
  find_package(codecov)
  add_coverage(SelfTest)
  list(APPEND LCOV_REMOVE_PATTERNS "'/usr/*'")
  coverage_evaluate()
endif()

# configure unit tests via CTest
add_test(NAME RunTests COMMAND $<TARGET_FILE:SelfTest> --order rand --rng-seed time)
set_tests_properties(RunTests PROPERTIES
  FAIL_REGULAR_EXPRESSION "Filters:"
  COST 15
)

# Because CTest does not allow us to check both return code _and_ expected
# output in one test, we run these commands twice. First time we check
# the output, the second time we check the exit code.
add_test(NAME List::Tests::Output COMMAND $<TARGET_FILE:SelfTest> --list-tests --verbosity high)
set_tests_properties(List::Tests::Output PROPERTIES
  PASS_REGULAR_EXPRESSION "[0-9]+ test cases"
  FAIL_REGULAR_EXPRESSION "Hidden Test"
)
# This should be equivalent to the old --list-test-names-only and be usable
# with --input-file.
add_test(NAME List::Tests::Quiet COMMAND $<TARGET_FILE:SelfTest> --list-tests --verbosity quiet)
# Sadly we cannot ask for start-of-line and end-of-line in a ctest regex,
# so we fail if we see space/tab at the start...
set_tests_properties(List::Tests::Quiet PROPERTIES
  PASS_REGULAR_EXPRESSION "\"#1905 -- test spec parser properly clears internal state between compound tests\"[\r\n]"
  FAIL_REGULAR_EXPRESSION "[ \t]\"#1905 -- test spec parser properly clears internal state between compound tests\""
)
add_test(NAME List::Tests::ExitCode COMMAND $<TARGET_FILE:SelfTest> --list-tests --verbosity high)
add_test(NAME List::Tests::XmlOutput COMMAND $<TARGET_FILE:SelfTest> --list-tests --verbosity high -r xml)
set_tests_properties(List::Tests::XmlOutput PROPERTIES
  PASS_REGULAR_EXPRESSION "<Line>[0-9]+</Line>"
  FAIL_REGULAR_EXPRESSION "[0-9]+ test cases"
)

add_test(NAME List::Tags::Output COMMAND $<TARGET_FILE:SelfTest> --list-tags)
set_tests_properties(List::Tags::Output PROPERTIES
  PASS_REGULAR_EXPRESSION "[0-9]+ tags"
  FAIL_REGULAR_EXPRESSION "\\[\\.\\]")
add_test(NAME List::Tags::ExitCode COMMAND $<TARGET_FILE:SelfTest> --list-tags)
add_test(NAME List::Tags::XmlOutput COMMAND $<TARGET_FILE:SelfTest> --list-tags -r xml)
set_tests_properties(List::Tags::XmlOutput PROPERTIES
  PASS_REGULAR_EXPRESSION "<Count>18</Count>"
  FAIL_REGULAR_EXPRESSION "[0-9]+ tags"
)

add_test(NAME List::Reporters::Output COMMAND $<TARGET_FILE:SelfTest> --list-reporters)
set_tests_properties(List::Reporters::Output PROPERTIES PASS_REGULAR_EXPRESSION "Available reporters:")
add_test(NAME List::Reporters::ExitCode COMMAND $<TARGET_FILE:SelfTest> --list-reporters)
add_test(NAME List::Reporters::XmlOutput COMMAND $<TARGET_FILE:SelfTest> --list-reporters -r xml)
set_tests_properties(List::Reporters::XmlOutput PROPERTIES
  PASS_REGULAR_EXPRESSION "<Name>compact</Name>"
  FAIL_REGULAR_EXPRESSION "Available reporters:"
)

add_test(NAME List::Listeners::Output
  COMMAND
    $<TARGET_FILE:SelfTest> --list-listeners
)
set_tests_properties(List::Listeners::Output
  PROPERTIES
    PASS_REGULAR_EXPRESSION "Registered listeners:"
)
add_test(NAME List::Listeners::ExitCode
  COMMAND
    $<TARGET_FILE:SelfTest> --list-listeners
)
add_test(NAME List::Listeners::XmlOutput
  COMMAND
    $<TARGET_FILE:SelfTest>
      --list-listeners
      --reporter xml
)
set_tests_properties(List::Listeners::XmlOutput
  PROPERTIES
    PASS_REGULAR_EXPRESSION "<RegisteredListeners>"
    FAIL_REGULAR_EXPRESSION "Registered listeners:"
)

add_test(NAME NoAssertions COMMAND $<TARGET_FILE:SelfTest> -w NoAssertions "An empty test with no assertions")
set_tests_properties(NoAssertions PROPERTIES PASS_REGULAR_EXPRESSION "No assertions in test case")

# We cannot combine a regular expression on output with return code check
# in one test, so we register two instead of making a checking script because
# the runtime overhead is small enough.
add_test(NAME TestSpecs::CombiningMatchingAndNonMatchingIsOk-1 COMMAND $<TARGET_FILE:SelfTest> Tracker, "___nonexistent_test___")

add_test(NAME TestSpecs::CombiningMatchingAndNonMatchingIsOk-2 COMMAND $<TARGET_FILE:SelfTest> Tracker, "___nonexistent_test___")
set_tests_properties(TestSpecs::CombiningMatchingAndNonMatchingIsOk-2 PROPERTIES
  PASS_REGULAR_EXPRESSION "No test cases matched '\"___nonexistent_test___\"'"
  FAIL_REGULAR_EXPRESSION "No tests ran"
)

add_test(NAME TestSpecs::NoMatchedTestsFail
  COMMAND $<TARGET_FILE:SelfTest> "___nonexistent_test___"
)
set_tests_properties(TestSpecs::NoMatchedTestsFail
  PROPERTIES
    WILL_FAIL ON
)
add_test(NAME TestSpecs::OverrideFailureWithNoMatchedTests
  COMMAND $<TARGET_FILE:SelfTest> "___nonexistent_test___" --allow-running-no-tests
)

add_test(NAME TestSpecs::OverrideAllSkipFailure
  COMMAND $<TARGET_FILE:SelfTest> "tests can be skipped dynamically at runtime" --allow-running-no-tests
)

add_test(NAME TestSpecs::NonMatchingTestSpecIsRoundTrippable
  COMMAND $<TARGET_FILE:SelfTest> Tracker, "this test does not exist" "[nor does this tag]"
)
set_tests_properties(TestSpecs::NonMatchingTestSpecIsRoundTrippable
  PROPERTIES
    PASS_REGULAR_EXPRESSION "No test cases matched '\"this test does not exist\" \\[nor does this tag\\]'"
)

add_test(NAME Warnings::UnmatchedTestSpecIsAccepted
  COMMAND $<TARGET_FILE:SelfTest> Tracker --warn UnmatchedTestSpec
)
set_tests_properties(Warnings::UnmatchedTestSpecIsAccepted
  PROPERTIES
    FAIL_REGULAR_EXPRESSION "Unrecognised warning option: "
)

=== tests/ExtraTests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(Catch2ExtraTests LANGUAGES CXX)

message(STATUS "Extra tests included")

add_test(
  NAME TestShardingIntegration
  COMMAND Python3::Interpreter ${CATCH_DIR}/tests/TestScripts/testSharding.py $<TARGET_FILE:SelfTest>
)
set_tests_properties(TestShardingIntegration
  PROPERTIES
    LABELS "uses-python"
)

add_test(
  NAME TestSharding::OverlyLargeShardIndex
  COMMAND $<TARGET_FILE:SelfTest>  --shard-index 5 --shard-count 5
)
set_tests_properties(TestSharding::OverlyLargeShardIndex
  PROPERTIES
    PASS_REGULAR_EXPRESSION "The shard count \\(5\\) must be greater than the shard index \\(5\\)"
)

# The MinDuration reporting tests do not need separate compilation, but
# they have non-trivial execution time, so they are categorized as
# extra tests, so that they are run less.
add_test(NAME MinDuration::SimpleThreshold COMMAND $<TARGET_FILE:SelfTest> --min-duration 0.950 [min_duration_test])
set_tests_properties(MinDuration::SimpleThreshold
  PROPERTIES
    PASS_REGULAR_EXPRESSION "s: sleep_for_1000ms"
    FAIL_REGULAR_EXPRESSION "sleep_for_100ms"
    RUN_SERIAL ON  # The test is timing sensitive, so we want to run it
    # serially to avoid false positives on oversubscribed machines
)

# -d yes overrides the threshold, so we should see the faster test even
# with a ridiculous high min duration threshold
add_test(NAME MinDuration::DurationOverrideYes COMMAND $<TARGET_FILE:SelfTest> --min-duration 1.0 -d yes [min_duration_test])
set_tests_properties(MinDuration::DurationOverrideYes
  PROPERTIES
    PASS_REGULAR_EXPRESSION "s: sleep_for_100ms"
)

# -d no overrides the threshold, so we should never see any tests even
# with ridiculously low min duration threshold
add_test(NAME MinDuration::DurationOverrideNo COMMAND $<TARGET_FILE:SelfTest> --min-duration 0.0001 -d no [min_duration_test])
set_tests_properties(MinDuration::DurationOverrideNo
  PROPERTIES
    FAIL_REGULAR_EXPRESSION "sleep_for_250ms"
)

# ------------ end of duration reporting tests

# define folders used:
set(TESTS_DIR ${CATCH_DIR}/tests/ExtraTests)

add_executable(PrefixedMacros ${TESTS_DIR}/X01-PrefixedMacros.cpp)
target_compile_definitions(PrefixedMacros PRIVATE CATCH_CONFIG_PREFIX_ALL CATCH_CONFIG_RUNTIME_STATIC_REQUIRE)
# Macro configuration does not touch the compiled parts, so we can link
# it against the main library
target_link_libraries(PrefixedMacros Catch2WithMain)

add_test(NAME CATCH_CONFIG_PREFIX_ALL COMMAND PrefixedMacros -s)
set_tests_properties(CATCH_CONFIG_PREFIX_ALL
  PROPERTIES
    PASS_REGULAR_EXPRESSION "CATCH_"
    FAIL_REGULAR_EXPRESSION
    # The spaces are important -> They disambiguate between CATCH_REQUIRE
    # and REQUIRE without prefix.
    " REQUIRE; REQUIRE_FALSE; REQUIRE_THROWS; REQUIRE_THROWS_AS; REQUIRE_THROWS_WITH; REQUIRE_THROWS_MATCHES; REQUIRE_NOTHROW; CHECK; CHECK_FALSE; CHECKED_IF; CHECKED_ELSE; CHECK_NOFAIL; CHECK_THROWS; CHECK_THROWS_AS; CHECK_THROWS_WITH; CHECK_THROWS_MATCHES; CHECK_NOTHROW; REQUIRE_THAT; CHECK_THAT"
)

add_executable(DisabledMacros ${TESTS_DIR}/X02-DisabledMacros.cpp)
target_compile_definitions(DisabledMacros PRIVATE CATCH_CONFIG_DISABLE)
# Macro configuration does not touch the compiled parts, so we can link
# it against the main library
target_link_libraries(DisabledMacros Catch2WithMain)

add_test(NAME CATCH_CONFIG_DISABLE-1 COMMAND DisabledMacros -s)
set_tests_properties(CATCH_CONFIG_DISABLE-1
  PROPERTIES
    PASS_REGULAR_EXPRESSION "No tests ran"
    FAIL_REGULAR_EXPRESSION "This should not happen"
)
add_test(NAME CATCH_CONFIG_DISABLE-2 COMMAND DisabledMacros --list-tests)
set_tests_properties(CATCH_CONFIG_DISABLE-2
  PROPERTIES
    PASS_REGULAR_EXPRESSION "0 test cases"
)

add_executable(DisabledExceptions-DefaultHandler ${TESTS_DIR}/X03-DisabledExceptions-DefaultHandler.cpp)
add_executable(DisabledExceptions-CustomHandler ${TESTS_DIR}/X04-DisabledExceptions-CustomHandler.cpp)

foreach(target DisabledExceptions-DefaultHandler DisabledExceptions-CustomHandler)
  target_compile_options(${target}
    PUBLIC
      $<$<CXX_COMPILER_ID:MSVC>:/EHs-c-;/D_HAS_EXCEPTIONS=0>
      $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:GNU>,$<CXX_COMPILER_ID:QCC>,$<CXX_COMPILER_ID:AppleClang>>:-fno-exceptions>
  )
  target_link_libraries(${target} Catch2_buildall_interface)
endforeach()
target_compile_definitions(DisabledExceptions-CustomHandler PUBLIC CATCH_CONFIG_DISABLE_EXCEPTIONS_CUSTOM_HANDLER)


add_test(NAME CATCH_CONFIG_DISABLE_EXCEPTIONS-1 COMMAND DisabledExceptions-DefaultHandler "Tests that run")
set_tests_properties(CATCH_CONFIG_DISABLE_EXCEPTIONS-1
  PROPERTIES
    PASS_REGULAR_EXPRESSION "assertions: 4 \| 2 passed \| 2 failed"
    FAIL_REGULAR_EXPRESSION "abort;terminate;fatal"
)

# We must now test this works without the build flag.
add_executable(BazelReporterNoCatchConfig ${TESTS_DIR}/X30-BazelReporter.cpp)
target_link_libraries(BazelReporterNoCatchConfig Catch2WithMain)
add_test(NAME NO_CATCH_CONFIG_BAZEL_REPORTER-1
  COMMAND
  Python3::Interpreter "${CATCH_DIR}/tests/TestScripts/testBazelReporter.py" $<TARGET_FILE:BazelReporterNoCatchConfig> "${CMAKE_CURRENT_BINARY_DIR}"
)
set_tests_properties(NO_CATCH_CONFIG_BAZEL_REPORTER-1
  PROPERTIES
    LABELS "uses-python"
    ENVIRONMENT "BAZEL_TEST=1"
)

add_test(NAME BazelEnv::TESTBRIDGE_TEST_ONLY
  COMMAND
      $<TARGET_FILE:BazelReporterNoCatchConfig>
)
set_tests_properties(BazelEnv::TESTBRIDGE_TEST_ONLY
  PROPERTIES
    ENVIRONMENT "BAZEL_TEST=1;TESTBRIDGE_TEST_ONLY=Passing test case"
    PASS_REGULAR_EXPRESSION "All tests passed \\(1 assertion in 1 test case\\)"
)

add_test(NAME BazelEnv::Sharding
  COMMAND
    Python3::Interpreter "${CATCH_DIR}/tests/TestScripts/testBazelSharding.py"
      $<TARGET_FILE:BazelReporterNoCatchConfig>
      "${CMAKE_CURRENT_BINARY_DIR}"
)
set_tests_properties(BazelEnv::Sharding
  PROPERTIES
    LABELS "uses-python"
)

# The default handler on Windows leads to the just-in-time debugger firing,
# which makes this test unsuitable for CI and headless runs, as it opens
# up an interactive dialog.
if(NOT WIN32)
  add_test(NAME CATCH_CONFIG_DISABLE_EXCEPTIONS-2 COMMAND DisabledExceptions-DefaultHandler "Tests that abort")
  set_tests_properties(CATCH_CONFIG_DISABLE_EXCEPTIONS-2
    PROPERTIES
      PASS_REGULAR_EXPRESSION "Catch will terminate"
  )
endif()

add_test(NAME CATCH_CONFIG_DISABLE_EXCEPTIONS-3 COMMAND DisabledExceptions-CustomHandler "Tests that run")
set_tests_properties(CATCH_CONFIG_DISABLE_EXCEPTIONS-3
  PROPERTIES
    PASS_REGULAR_EXPRESSION "assertions: 4 \| 2 passed \| 2 failed"
    FAIL_REGULAR_EXPRESSION "====== CUSTOM HANDLER ======"
)

add_test(NAME CATCH_CONFIG_DISABLE_EXCEPTIONS-4 COMMAND DisabledExceptions-CustomHandler "Tests that abort")
set_tests_properties(CATCH_CONFIG_DISABLE_EXCEPTIONS-4
  PROPERTIES
    PASS_REGULAR_EXPRESSION "====== CUSTOM HANDLER ======"
)

add_executable(DeferredStaticChecks ${TESTS_DIR}/X05-DeferredStaticChecks.cpp)
target_link_libraries(DeferredStaticChecks PRIVATE Catch2WithMain)
target_compile_definitions(DeferredStaticChecks PRIVATE "CATCH_CONFIG_RUNTIME_STATIC_REQUIRE")

add_test(NAME DeferredStaticChecks COMMAND DeferredStaticChecks -r compact)
set_tests_properties(DeferredStaticChecks
  PROPERTIES
    PASS_REGULAR_EXPRESSION "test cases: 1 \\| 1 failed\nassertions: 3 \\| 3 failed"
)

add_executable(FallbackStringifier ${TESTS_DIR}/X10-FallbackStringifier.cpp)
target_compile_definitions(FallbackStringifier PRIVATE CATCH_CONFIG_FALLBACK_STRINGIFIER=fallbackStringifier)
target_link_libraries(FallbackStringifier Catch2WithMain)

add_test(NAME FallbackStringifier COMMAND FallbackStringifier -r compact -s)
set_tests_properties(FallbackStringifier
  PROPERTIES
    PASS_REGULAR_EXPRESSION "foo{} for: { !!! }"
)

add_executable(DisableStringification ${TESTS_DIR}/X11-DisableStringification.cpp)
target_compile_definitions(DisableStringification PRIVATE CATCH_CONFIG_DISABLE_STRINGIFICATION)
target_link_libraries(DisableStringification Catch2WithMain)
add_test(NAME CATCH_CONFIG_DISABLE_STRINGIFICATION COMMAND DisableStringification -r compact -s)
set_tests_properties(CATCH_CONFIG_DISABLE_STRINGIFICATION
  PROPERTIES
    PASS_REGULAR_EXPRESSION "Disabled by CATCH_CONFIG_DISABLE_STRINGIFICATION"
    FAIL_REGULAR_EXPRESSION  "Hidden{} == Hidden{}"
)

# This test touches windows.h, so it should only be compiled under msvc
if(MSVC)
  # This test fails if it does not compile and succeeds otherwise
  add_executable(WindowsHeader ${TESTS_DIR}/X90-WindowsHeaderInclusion.cpp)
  target_link_libraries(WindowsHeader Catch2WithMain)
  add_test(NAME WindowsHeader COMMAND WindowsHeader -r compact)
  list(APPEND CATCH_TEST_TARGETS ${EXTRA_TEST_BINARIES} WindowsHeader)
endif()

add_executable(PartialTestCaseEvents ${TESTS_DIR}/X21-PartialTestCaseEvents.cpp)
target_link_libraries(PartialTestCaseEvents PRIVATE Catch2WithMain)
add_test(
  NAME PartialTestCaseEvents
  COMMAND Python3::Interpreter ${CATCH_DIR}/tests/TestScripts/testPartialTestCaseEvent.py $<TARGET_FILE:PartialTestCaseEvents>
)
set_tests_properties(PartialTestCaseEvents
  PROPERTIES
    LABELS "uses-python"
)

add_executable(BenchmarksInCumulativeReporter ${TESTS_DIR}/X22-BenchmarksInCumulativeReporter.cpp)
target_link_libraries(BenchmarksInCumulativeReporter PRIVATE Catch2::Catch2WithMain)
add_test(
  NAME BenchmarksInCumulativeReporter
  COMMAND BenchmarksInCumulativeReporter --reporter testReporter
)
set_tests_properties(BenchmarksInCumulativeReporter
  PROPERTIES
    PASS_REGULAR_EXPRESSION "1\n2\n3\n4\n5\n"
    COST 30
)

add_executable(CasingInReporterNames ${TESTS_DIR}/X23-CasingInReporterNames.cpp)
target_link_libraries(CasingInReporterNames PRIVATE Catch2::Catch2WithMain)
add_test(
  NAME Reporters::registration-is-case-preserving
  COMMAND CasingInReporterNames --list-reporters
)
set_tests_properties(Reporters::registration-is-case-preserving
  PROPERTIES
    PASS_REGULAR_EXPRESSION "testReporterCASED"
)
add_test(
  NAME Reporters::selection-is-case-insensitive
  COMMAND  CasingInReporterNames -r testReportercased
)
set_tests_properties(Reporters::selection-is-case-insensitive
  PROPERTIES
    PASS_REGULAR_EXPRESSION "TestReporter constructed"
)

add_executable(CapturedStdoutInTestCaseEvents ${TESTS_DIR}/X27-CapturedStdoutInTestCaseEvents.cpp)
target_link_libraries(CapturedStdoutInTestCaseEvents PRIVATE Catch2::Catch2WithMain)
add_test(
  NAME Reporters::CapturedStdOutInEvents
  COMMAND CapturedStdoutInTestCaseEvents
    --reporter test-reporter
)
set_tests_properties(Reporters::CapturedStdOutInEvents
  PROPERTIES
    PASS_REGULAR_EXPRESSION "X27 - TestReporter constructed"
    FAIL_REGULAR_EXPRESSION "X27 ERROR"
)

if(MSVC)
  set(_NullFile "NUL")
else()
  set(_NullFile "/dev/null")
endif()

add_executable(ListenerStdoutCaptureInMultireporter ${TESTS_DIR}/X24-ListenerStdoutCaptureInMultireporter.cpp)
target_link_libraries(ListenerStdoutCaptureInMultireporter PRIVATE Catch2::Catch2WithMain)

# This test checks that there is nothing written out from the process,
# but if CMake is running the tests under Valgrind or similar tool, then
# that will write its own output to stdout and the test would fail.
if(NOT MEMORYCHECK_COMMAND)
  add_test(
    NAME MultiReporter::NoncapturingListenerDoesntCauseStdoutPassThrough
    COMMAND ListenerStdoutCaptureInMultireporter
      --reporter xml::out=${_NullFile}
      --reporter junit::out=${_NullFile}
  )

  set_tests_properties(MultiReporter::NoncapturingListenerDoesntCauseStdoutPassThrough
    PROPERTIES
      PASS_REGULAR_EXPRESSION "X24 - NonCapturingListener initialized"
      FAIL_REGULAR_EXPRESSION "X24 - FooBarBaz"
  )
endif()

add_executable(ListenerCanAskForCapturedStdout ${TESTS_DIR}/X25-ListenerCanAskForCapturedStdout.cpp)
target_link_libraries(ListenerCanAskForCapturedStdout PRIVATE Catch2::Catch2WithMain)
add_test(
  NAME MultiReporter::CapturingListenerCausesStdoutCapture
  COMMAND ListenerCanAskForCapturedStdout
    --reporter compact::out=${_NullFile}

=== tests/TestScripts/DiscoverTests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(discover-tests-test LANGUAGES CXX)

add_executable(tests register-tests.cpp)
add_subdirectory(${CATCH2_PATH} catch2-build)
target_link_libraries(tests PRIVATE Catch2::Catch2WithMain)

enable_testing()
include(Catch)
set(extra_args)
if(CMAKE_VERSION GREATER_EQUAL 3.27)
  list(APPEND extra_args
    DL_PATHS "${CMAKE_CURRENT_LIST_DIR};${CMAKE_CURRENT_LIST_DIR}/.."
  )
endif()
catch_discover_tests(
  tests
  ADD_TAGS_AS_LABELS
  DISCOVERY_MODE PRE_TEST
  ${extra_args}
)

# DISCOVERY_MODE <POST_BUILD|PRE_TEST>

=== PKGBUILD ===
# Maintainer: David Grayson <davidegrayson@gmail.com>

_realname=catch
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.11.0
pkgrel=1
pkgdesc="A modern, C++-native, header-only, test framework for unit-tests, TDD and BDD using C++11 and later (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: catch2'
  'gentoo: dev-cpp/catch'
)
url='https://github.com/catchorg/Catch2'
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
license=('spdx:BSL-1.0')
source=(https://github.com/catchorg/Catch2/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz)
sha256sums=('82fa1cb59dc28bab220935923f7469b997b259eb192fb9355db62da03c2a3137')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    ${_extra_config[@]} \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "../Catch2-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"
  projects/SelfTest.exe
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}"/Catch2-${pkgver}/LICENSE.txt "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
